/* D-RexGxt - D-RexGxt - GUI Design Tool for GWT
 * Copyright (c) 2008,  KPS Corporation
 * All rights reserved.
 *
 * Open Source License
 * ------------------------------------------------------------------------------------------
 * D-RexGxt is licensed under the terms of the Open Source GPL 3.0 license.
 *
 * http://www.gnu.org/licenses/gpl.html
 *
 * --
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 */
package jp.co.kpscorp.gwt.client.design.gxt.service.comp;

import java.util.Arrays;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import jp.co.kpscorp.gwt.client.design.WidgetServiceBase;
import jp.co.kpscorp.gwt.client.design.delegate.Delegate;
import jp.co.kpscorp.gwt.client.design.gxt.GxtUtil;
import jp.co.kpscorp.gwt.client.design.gxt.delegate.comp.TreeItemDelegate;

import com.extjs.gxt.ui.client.widget.Component;
import com.extjs.gxt.ui.client.widget.tree.Tree;
import com.extjs.gxt.ui.client.widget.tree.TreeHelper;
import com.extjs.gxt.ui.client.widget.tree.TreeItem;

public class WsTreeItem extends WidgetServiceBase {

	private String fieldString = "TreeItem ";

	private String instanceString = " = new TreeItem();";

	private String tag = "gxTRI";

	public WsTreeItem(Component widget) {
		super();
		this.widget = widget;
		baseDelegate = new TreeItemDelegate(this, widget);
		delegates.add(baseDelegate);
		props = Arrays.asList(baseDelegate.getProps());
		innerProps = Arrays.asList(baseDelegate.getInnerProps());
	}

	public Component getInstance() {
		TreeItem ti = new TreeItem();
		// (prevent nullpo) set dummy Tree
		TreeHelper.setTree(ti, new Tree());
		return ti;
	}

	public String getLabel() {
		return "TreeItem";
	}

	public String getTag() {
		return tag;
	}

	public String getFieldString() {
		return fieldString;
	}

	public String getInstanceString() {
		return instanceString;
	}

	@Override
	public boolean isSetAfterRender() {
		return true;
	}

	@Override
	public List<String>[] makeSource(List<String>[] lists,
			Map<Object, Object> map) {
		// RootTreeItemを得る
		String fn = (String) map.get(this.widget);
		if (fn == null) {
			return super.makeSource(lists, map);
		}
		Iterator it = getDelegates().iterator();
		while (it.hasNext()) {
			Delegate delegate = (Delegate) it.next();
			delegate.makeSetterCode(widget, lists, getFieldString(),
					getInstanceString(), getTag(), fn, map);
		}
		return GxtUtil.makeAddCode(widget, lists, map, fn);
	}

}
